"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.SecurityLabel = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * The ``postgresql.SecurityLabel`` resource creates and manages security labels.
 *
 * See [PostgreSQL documentation](https://www.postgresql.org/docs/current/sql-security-label.html)
 *
 * > **Note:** This resource needs Postgresql version 11 or above.
 *
 * ## Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as postgresql from "@pulumi/postgresql";
 *
 * const myRole = new postgresql.Role("my_role", {
 *     name: "my_role",
 *     login: true,
 * });
 * const workload = new postgresql.SecurityLabel("workload", {
 *     objectType: "role",
 *     objectName: myRole.name,
 *     labelProvider: "pgaadauth",
 *     label: "aadauth,oid=00000000-0000-0000-0000-000000000000,type=service",
 * });
 * ```
 *
 * ## Import
 *
 * Security label is an attribute that can be added multiple times, so no import is needed, simply apply again.
 */
class SecurityLabel extends pulumi.CustomResource {
    /**
     * Get an existing SecurityLabel resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new SecurityLabel(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of SecurityLabel.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === SecurityLabel.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["label"] = state ? state.label : undefined;
            resourceInputs["labelProvider"] = state ? state.labelProvider : undefined;
            resourceInputs["objectName"] = state ? state.objectName : undefined;
            resourceInputs["objectType"] = state ? state.objectType : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.label === undefined) && !opts.urn) {
                throw new Error("Missing required property 'label'");
            }
            if ((!args || args.labelProvider === undefined) && !opts.urn) {
                throw new Error("Missing required property 'labelProvider'");
            }
            if ((!args || args.objectName === undefined) && !opts.urn) {
                throw new Error("Missing required property 'objectName'");
            }
            if ((!args || args.objectType === undefined) && !opts.urn) {
                throw new Error("Missing required property 'objectType'");
            }
            resourceInputs["label"] = args ? args.label : undefined;
            resourceInputs["labelProvider"] = args ? args.labelProvider : undefined;
            resourceInputs["objectName"] = args ? args.objectName : undefined;
            resourceInputs["objectType"] = args ? args.objectType : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(SecurityLabel.__pulumiType, name, resourceInputs, opts);
    }
}
exports.SecurityLabel = SecurityLabel;
/** @internal */
SecurityLabel.__pulumiType = 'postgresql:index/securityLabel:SecurityLabel';
//# sourceMappingURL=securityLabel.js.map